// Allan Bowhill

#include "Category.h"

Category::Category(char * pt, Category * pr, char * nam, int lv, status st, int * pm, char * cm)
: path(pt), parent(pr), name(nam), level(lv), state(st), parameter(pm), comment(cm)
	{
	if (state.has_comments)
		{
		commentaries = new (nothrow) Queue;
		assert (commentaries);
		}
	else
		commentaries = NULL;

	links = new (nothrow) Queue;
	assert(links);
	}


bool Category::print()
	{
	cout << "-------------" << endl;
	cout << "path: " << path << endl;
	cout << "Category: " << this << endl;
	cout << "parent: " << parent << endl;
	cout << "name: (" << &name << ")" << Category::getName() << endl;
	cout << "level: " << level << endl;
	cout << "status: " << state.has_comments << state.has_links << state.has_categories << endl;
	cout << "param: " << parameter << endl;

	for (int i=0; i < sizeof(*parameter)/sizeof(int); ++i)
		cout << parameter[i] << " ";

	cout << endl;
	
	cout << "Comment: " << comment << endl;
	cout << "subcategories: ";
	Vector::printList();

	if (commentaries != NULL)
		{
		cout << "Commentaries: "; 
		commentaries->printList();
		}

	cout << "-------------" << endl;
	return true;
	}


void Category::storeCategory(Category * aChild)
	{
	int size = Vector::getSize();
	Vector::addIndex(size, aChild);
	}


void Category::storeCommentary(char * aFileName)
	{
	commentaries->enQueue(aFileName);
	}


Category * Category::getSubCategory(int index)
	{
	Category * aCat = (Category *)Vector::peekIndex(index-1);
	return aCat;
	}

Category * Category::popSubCategory()
	{
	Category * aCat = (Category *)Vector::peekIndex(0);
	Vector::delIndex(0);
	return aCat;
	}

void Category::addLink(Category * aCat, char * Url, char * clickText, char * shortComment)
	{
	// now create a new Link object
	Link * aLink = new (nothrow) Link (Url, clickText, shortComment);
	assert(aLink);

	links->enQueue(aLink);
	}
