// Allan Bowhill

#include "../main.h"
#include "../LinkedList/LinkedList.h"
#include "../Vector/Vector.h"
#include "../Queue/Queue.h"
#include "../Link/Link.h"
#include "../Commentary/Commentary.h"

#ifndef CATEGORY_H
#define CATEGORY_H

using namespace std; 

// Class: Category
//
// Remarks:
// 

class Category: private Vector
	{
	public:

		Category::Category(char * path, Category * pr, char * nam, int lv, status st, int * pm, char * cm);
		Category::~Category() {}

		void Category::addLink(Category * aCat, char * Url, char * clickText, char * shortComment);

		void setStatus(status dstat)		{ state = dstat;}
		void setShortDescription(char * cm)	{ comment = cm; }

		void storeCategory(Category * aChild);
		void storeCommentary(char * aFileName);

		Category * getSubCategory(int index);
		Category * popSubCategory();
		char     * getPath() 		{ return path; }
		Category * getParent()		{ return parent; }
		char     * getName()		{ return name; }
		int        getLevel()		{ return level; }
		status     getStatus()		{ return state; }
		int      * getParameter()	{ return parameter; }
		char     * getComment()		{ return comment; }
		Link     * popLink()		{ return (Link*)links->deQueue(); }
		bool       linksEmpty()		{ return links->empty(); }
		int        getLinkSize()	{ return links->getSize(); }

		bool print();

	private:
		Category::Category(const Category & copy) {}

		char     * path;	// access path
		Category * parent;	// pointer to parent
		char     * name;	// name
		int        level;	// level in tree
		status     state;	// objects contained within
		int      * parameter;	// CGI parameter
		char     * comment;	// short description

		Queue    * commentaries;// commentary queue
		Queue    * links;	// links queue
		
	};

#endif
