// Allan Bowhill

#ifndef CONFIG_H
#define CONFIG_H

#include "../main.h"
#include <fstream>
#include <string>


using namespace std; 

// Class: Config
//
// Remarks: Reads and stores configuration options
// 


class Config
	{
	public:
		// constructor
		Config::Config();

		// get emp document root
		const char * Config::getEmpRoot(void);

	private:
		// privatized copy constructor
		Config::Config(const Config & aConfig) {}

		// path of emp root
		const char * empRoot;

		// config file path
		char * configPath;

		// check for existence of claimed emp doc root
		bool Config::checkEmpRoot(const char * path);

		// check for existence of config file
		bool Config::checkConfigFile(const char * path);

		// read config file
		bool Config::readConfigFile(ifstream & config, const char * path);

		// get value for associated config key : buf
		bool Config::getValue(string & buf);

	};

#endif
