// Allan Bowhill

#ifndef DATASOURCE_H
#define DATASOURCE_H

#include "../main.h"
#include "../WebTree/WebTree.h"

using namespace std; 

// Class: DataSource
//
// Remarks:
// If you write your own data source module, inherit publically from this class.
// You must provide my program initialize() and transfer() functions.
// You are provided with access to five webTree functions to transfer
// your categories, links and comments to the web tree.


class DataSource
	{
	public:
		virtual void initialize(WebTree * wt)=0;	// initialize data source
		virtual void transfer()=0; 			// transfer data to web tree
		virtual void print()=0;

	private:
//		webTree * WT;
	};

#endif
