// Allan Bowhill

#ifndef DISK_H
#define DISK_H

#include "../main.h"
#include <fts.h>
#include "../DataSource/DataSource.cc"
#include "../Category/Category.h"
#include "../WebTree/WebTree.h"

using namespace std; 

// Class: Disk
//
// Remarks:
// 


class Disk : public DataSource
	{
	public:
		Disk::Disk();				// initialize Disk object
		virtual Disk::~Disk() { }		// destructor
			
		virtual void Disk::initialize(WebTree * wt);	// required by DataSource: init disk
		virtual void Disk::transfer();		// transfer Disk objects to tree

		void Disk::print() { cout << "Disk is ready" << endl;}


	private:

		Disk::Disk(const Disk & aDisk) {}	// privatized copy constructor

		status getDirStatus(FTS * FO);		// get status code of dir
		void Disk::testType(FTSENT * entry);	// detect and process nonfatal filesystem errors
		bool Disk::isCommentary(FTSENT * ent);	// search entry for Commentary suffix
		void Disk::readDisk();			// read files and dirs on disk
		void Disk::makeObjects();		// create objects for dirs and files

		WebTree * WT;			// WebTree pointer
		FTS * FO;			// Pointer to FTS struct
		FTSENT * entry;			// Entry to current FTSENT struct
		FTSENT * lastEntry;		// Entry to last FTSENT struct

	};

#endif
