// Allan Bowhill

#include "Display.h"

void Display::print(WebTree * WT, Parameter * aParameter)
	{
	Category * Root = WT->getRequestedRoot();

	cout 
	<< PREHEAD 
	<< endl
	<< XMLDEC
	<< endl
	<< DOCTYPE
	<< endl
	<< OPEN_HTML
	<< endl
	<< OPEN_HEAD
	<< endl
	<< STYLESHEET
	<< endl
	<< OPEN_TITLE
	<< endl
	<< Root->getComment()
	<< endl
	<< CLOSE_TITLE
	<< endl
	<< CLOSE_HEAD
	<< endl
	<< OPEN_BODY
	<< endl
	;

	cout 
	<< "<" 
	<< CATEGORY_TITLE_FONT_SCALE 
	<< " "
	<< "align=" 
	<< "\"" 
	<< TITLE_ALIGN 
	<< "\"" 
	<< ">"
	<< Root->getName()
	<< "</" 
	<< CATEGORY_TITLE_FONT_SCALE 
	<< ">" 
	<< endl
	<< endl
	<< OPEN_TABLE 
	<< endl
	;

	status state = Root->getStatus();

	Category * aCat;

	if(state.has_categories)
		{
		while((aCat = Root->popSubCategory()) != NULL)
			{
			cout 
			<< OPEN_ROW 
			<< endl 
			<< OPEN_CELL_HAS_CAT
			<< OPEN_ANCHOR
			<< OPEN_HREF
			<< "http://" 
			<< aParameter->getServerName() 
			<< aParameter->getScriptName() << "?" << QUERY_PREFIX
			;
		
			int lev = aCat->getLevel();
			int * parm = aCat->getParameter();

			// read params in reverse
			for (int i=lev; i > 0; --i)
				cout << parm[i] << ".";

			cout
			<< parm[0]
			<< CLOSE_HREF 
			<< aCat->getName() 
			<< CLOSE_ANCHOR
			<< CLOSE_CELL 
			<< endl 
			<< OPEN_CELL_CAT
			;
		
			status subState = aCat->getStatus();
			Category * sCat;

			if(subState.has_categories)
				{
				bool is_first = true;
				
				while ((sCat = aCat->popSubCategory()) != NULL)
					{
					cout 
					<< OPEN_ANCHOR
					<< OPEN_HREF
					<< "http://" 
					<< aParameter->getServerName()
			     		<< aParameter->getScriptName() 
					<< "?" 
					<< QUERY_PREFIX
					;

					int lev = sCat->getLevel();
					int * parm = sCat->getParameter();
					// read params in reverse
					for (int i=lev; i > 0; --i)
						cout << parm[i] << ".";
					cout 
					<< parm[0]
					<< CLOSE_HREF
					;

					if(is_first)
						is_first = false;
					else
						cout << ", ";
					cout 
					<< sCat->getName() 
					<< CLOSE_ANCHOR 
					<< endl
					;

					}		
				}
			cout 
			<< CLOSE_CELL 
			<< endl 
			<< CLOSE_ROW 
			<< endl
			;

			}
		}
	// Do links here
	if(state.has_links)
		{
		Link * aLink;

		while (!Root->linksEmpty())
			{
			aLink = Root->popLink();
			char * Url = aLink->getUrl();
			char * clickText = aLink->getClickText();
			char * shortDesc = aLink->getShortDescr();

		 	cout 
			<< OPEN_ROW 
			<< endl
			<< OPEN_CELL_HAS_LINK
			<< OPEN_ANCHOR
			<< OPEN_HREF
			<< Url
			<< CLOSE_HREF 
			<< clickText
			<< CLOSE_ANCHOR
			<< CLOSE_CELL 
			<< endl 
			<< OPEN_CELL_LINK 
			<< shortDesc
			<< CLOSE_CELL
			<< endl
			<< CLOSE_ROW
			<< endl;
			;

			}
		cout << CLOSE_TABLE << endl;
		}
	cout
	<< CLOSE_BODY
	<< endl
	<< CLOSE_HTML
	<< endl
	<< endl
	;

	}

