// Allan Bowhill

#ifndef SESSION_H
#define SESSION_H

#include "../main.h"
#include <iostream>
#include <fstream>
#include "../Parameter/Parameter.h"
#include "../Disk/Disk.h"
#include "../Link/Link.h"
#include "../WebTree/WebTree.h"
#include "../Display/Display.h"
#include "../Config/Config.h"

using namespace std; 

// Class: Session
//
// Remarks:
// 


class Session
	{
	public:
		Session(DataSource * aDataSource);
		~Session() { }
		
		bool processRequest();
		void display();


	private:
		Session(const Session & copy) { }

		Parameter * aParameter;
		DataSource * aDataSource;
		Config * aConfig;
		WebTree * WT;

		const char * empRoot;
		int * parameters;
		void traverse(Category * aCat);
		void makePostObjects();
		void makeLinks();
		void readCommentaryFiles();
		void processShortDescription(char *);
	};

#endif

