// Allan Bowhill

#ifndef STACK_H
#define STACK_H

#include "../LinkedList/LinkedList.h"

using namespace std; 

// Class: Stack
//
// Remarks:
// Extends Doubly-linked list, circular


class Stack: private LinkedList
	{
	protected:

		// constructors
		Stack::Stack() { }

		// destructor
		Stack::~Stack() { }

		// push a node to the stack
		bool Stack::push(void *);

		// pop a node from stack
		bool Stack::pop();

		// peek at top of stack
		void * Stack::peek();

		// print stack
		bool Stack::printList();

		// check empty
		bool Stack::empty();

		// clear stack
		bool Stack::clear();

		// get copy of stack
		int * Stack::getCopy();

		// increment value in head of stack
		void Stack::incr();

		// return size of stack
		int Stack::getSize();

	private:
		// copy constructor
		Stack::Stack(Stack & copy) { }
		
	};
#endif
