//Allan Bowhill

#include "WebTree.h"

// sets root category to name
WebTree::WebTree(const char * rootname) :
	rootName(rootname), 
	rootCategory(NULL), 
	parentCategory(NULL),
	lastCategory(NULL), 
	level(-1)
	{
	// nothing done here
	// initialization is done explicitly using DataSource::Initialize()
	}

WebTree::~WebTree()
	{
	}

// adds a category to the tree, under parent

Category * WebTree::addCategory(char * path, char * name, int newlevel, status state, char * comment)
	{
	int * parameter;
		
	// we have gone down one level in heirarchy
	if (level < newlevel)
		{
		int * pint = new (nothrow) int [1];
		assert(pint);
		*pint = SMALLEST_PARAM;
		parentCategory = lastCategory;
		Stack::push(pint);
		parameter = Stack::getCopy();
		}

	// we have not changed in heirarchy
	else if (level == newlevel)
		{
		Stack::incr();
		parameter = Stack::getCopy();
		}

	// we have gone up in heirarchy
	else if (level > newlevel)
		{
		while (level > newlevel)
			{
			lastCategory = lastCategory->getParent();
			--level;
			Stack::pop();
			}
		parentCategory = lastCategory->getParent();
		Stack::incr();
		parameter = Stack::getCopy();
		}

	level = newlevel;

	// create category
	lastCategory = new (nothrow) Category(path, parentCategory, name, level, state, parameter, comment);
	assert(lastCategory);

	// Store this category in Parent's list
	if (parentCategory != NULL)
		parentCategory->storeCategory(lastCategory);

	return lastCategory;
	}


// set root category
Category * WebTree::addRoot(Category * theRoot)
	{
	rootCategory = theRoot;
	return rootCategory;
	}

// add commentary name to category's commentaries queue
void WebTree::addCommentary(Category * aCategory, char * fileName)
	{
	aCategory->storeCommentary(fileName);
	}

// adds a category to the tree
const char * WebTree::getRootName()
	{
	return rootName;
	}

// adds a category to the tree
Category * WebTree::getRoot()
	{
	return rootCategory;
	}

bool WebTree::print()
	{
	cout << "WebTree is alive" << rootName << endl;
	return true;
	}

void WebTree::setRequestedRoot(Category * aCat)
	{
	requestedRoot = aCat;
	}

Category * WebTree::getRequestedRoot()
	{
	return requestedRoot;
	}

void WebTree::addLink(Category * aCat, char * Url, char * clickText, char * shortComment)
	{
	aCat->addLink(aCat, Url, clickText, shortComment);
	}
