// Allan Bowhill

#ifndef WEBTREE_H
#define WEBTREE_H

#include "../main.h"
#include "../LinkedList/LinkedList.h"
#include "../Stack/Stack.h"
#include "../Link/Link.h"
#include "../Category/Category.h"

using namespace std; 

// Class: WebTree
//
// Remarks:
//
// This is a tree of Categories, Links and Comments that the user has permission to 
// access. Each Category and Comment are automatically given CGI return parameters.
// 


class WebTree: private Stack
	{
        public:

		// sets root category to name
		WebTree::WebTree(const char * name);
		WebTree::~WebTree();

		// adds a category to the tree
		Category * WebTree::addCategory(char * path, char * name, int newlevel, status state, char * comment);

		// add a node to root
		Category * WebTree::addRoot(Category * theRoot);

		// get root node
		Category * getRoot();

		void setRequestedRoot(Category * aCat);
		Category * getRequestedRoot();

		// get root name
		const char * WebTree::getRootName();

		// print tree
		bool WebTree::print();

		// adds a link to Category
		void addLink(Category * aCat, char * Url, char * clickText, char * shortComment);

		// Add a comment to the tree
		void WebTree::addCommentary(Category * aCategory, char * fileName);

	private:
		
		WebTree::WebTree(const WebTree & copy) {}
		const char * rootName;
		Category * rootCategory;
		Category * requestedRoot;
		Category * lastCategory;
		Category * parentCategory;
		int level;


	};

#endif
