#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <sys/errno.h>
#include <stdio.h>
#include <string>
#include <iomanip>
#include <new>
#include <cstdlib>
#include <cassert>
#include <limits.h>
#include <time.h>
#include <cmath>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <new>


#ifndef MAIN_H
#define MAIN_H


#define PREF_EMP_ROOT "/usr/local/www/emp"
#define DEFAULT_EMP_ROOT "emp"
#define PREF_CONFIG "/usr/local/etc/emp/emp.cfg"
#define DEFAULT_CONFIG "emp.cfg"
#define EMP_ROOT_KEY "emproot"

#define DEBUG 0
#define DATA_SOURCE_MODULE "Disk"

// Apache environment variables

#define QUERY_STRING "QUERY_STRING"
#define HTTP_USER_AGENT "HTTP_USER_AGENT"
#define REMOTE_ADDR "REMOTE_ADDR"
#define SERVER_ADDR "SERVER_ADDR"
#define SERVER_NAME "SERVER_NAME"
#define SCRIPT_NAME "SCRIPT_NAME"

// file names and extensions used by emp

#define LINKS_FILE "links" 		// links file
#define COMMENT_SUFFIX ".comment" 	// under development

// some system definitions

#define SMALLEST_PARAM 1		// smallest parameter integer allowed
#define QUERY_PREFIX "q="		// this precedes CGI parameter string
#define PARAM_FIELD_SEP '.'		// character that seperates parameter fields
#define PREHEAD "Content-Type: text/html; charset=iso-8859-1\n\n"  // html header

// XHTML 1.0 Transitional tags

#define XMLDEC "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
#define DOCTYPE "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"DTD/xhtml1-transitional.dtd\">"
#define OPEN_HTML "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\" xml:lang=\"en\">"
#define OPEN_HEAD "<head>"
#define OPEN_TITLE "<title>"
#define OPEN_BODY "<body>"
#define CLOSE_HEAD "</head>"
#define CLOSE_TITLE "</title>"
#define CATEGORY_TITLE_FONT_SCALE "h3"
#define TITLE_ALIGN "center"
#define PARA "<p>"
#define OPEN_TABLE "<table border = \"0\" align = \"center\">"
#define OPEN_ROW "<tr>"
#define OPEN_CELL_HAS_CAT "<td bgcolor=\"#ffffcc\">"
#define OPEN_CELL_CAT "<td bgcolor=\"#ffccff\">"
#define OPEN_CELL_HAS_LINK "<td bgcolor=\"#ccffdd\">"
#define OPEN_CELL_LINK "<td bgcolor=\"#ddffcc\">"
#define OPEN_ANCHOR "<a "
#define OPEN_HREF "href = \""
#define CLOSE_HREF "\">"
#define CLOSE_ANCHOR "</a>"
#define CLOSE_CELL "</td>"
#define CLOSE_ROW "</tr>"
#define CLOSE_TABLE "</table>"
#define CLOSE_BODY "</body>"
#define CLOSE_HTML "</html>"


// This is the embedded stylesheet.
// It makes things run with *much* less overhead
// Change it if you like.


#define S1 "<style type = \"text/css\">"
#define S2 "body { font: 10pt Verdana, sans-serif; color: black; background-color: white; }"
#define S3 "a:visited {color: blue;}"
#define S4 "a {text-decoration: none;}"
#define S5 "tr { font: 9pt Verdana, sans-serif; }"
#define S6 "h1, h2, h3, h4, h5, h6 { font: bold 12pt Arial, sans-serif; letter-spacing: 3px; Color: purple; }"
#define S7 "</style>"
#define STYLESHEET S1 "\n" S2 "\n" S3 "\n" S4 "\n" S5 "\n" S6 "\n" S7 "\n"


// This is the critical error message.
// It is sent every time emp can't do anything but exit.

#define ERR1 PREHEAD OPEN_HEAD "\n" OPEN_TITLE "\nError\n" CLOSE_TITLE "\n" CLOSE_TITLE "\n"
#define ERR2 OPEN_BODY "<H3>Urecoverable emp Error: please check Apache logfile</H3>\n"
#define ERR3 CLOSE_BODY CLOSE_HTML "\n"
#define ERROR_ABORT ERR1 ERR2 ERR3


typedef const void * Citem;

// directory status struct

typedef struct dstatus
	{
	unsigned int has_categories : 1;
	unsigned int has_comments : 1;
	unsigned int has_links : 1;
	}
status;


#endif
